--  Copyright (2008-2013) Cédric Coussinet (cedric.coussinet@nomoseed.net)
--
--  This program is free software: you can redistribute it and/or modify
--  it under the terms of the GNU Affero General Public License as published
--  by the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
--  GNU Affero General Public License for more details.

--  You should have received a copy of the GNU Affero General Public License
--  along with this program. If not, see <http://www.gnu.org/licenses/>

package body Nomo.Internal_Messages.Conclusions.Delayed.Predictive is

   procedure Adjust_Prediction (This      : in out Predictive_Conclusion;
                                Time_Span : in Positive_Time_Interval;
                                Bonus     : in Positive_Time_Interval) is
   begin
      This.Time_Span := - Time_Span;
      if Bonus = 0 then
         This.Lateness := Positive_Time (Time_Span + 1);
      else
         This.Lateness := Positive_Time (Time_Span + Bonus);
      end if;
   end Adjust_Prediction;

   procedure Adjust_Prediction (This  : in out Predictive_Conclusion;
                                Bonus : in Positive_Time_Interval) is
   begin
      if Bonus = 0 then
         This.Lateness := Positive_Time (- This.Time_Span + 1);
      else
         This.Lateness := Positive_Time (- This.Time_Span + Bonus);
      end if;
   end Adjust_Prediction;

end Nomo.Internal_Messages.Conclusions.Delayed.Predictive;
